import java.util.Arrays;

/**
 *  Arrays
 */
public class UsingArrays {


    public static void main(String[] args) {
        primitiveArray();
        referenceArray();
        shortForLoop();
        advancedUseOfArray();
    }



    public static void primitiveArray() {
        int[] iarr;   // Bara *en* variabel med värde null

        //iarr = { 1,2,3,4,5 };    // Nix, inga array literaler

        int[] iarr2 = {1, 2, 3, 4, 5}; // Ok, deklarera och initiera (fix storlek!)

        System.out.println(iarr2); // Inte bra utskrift
        System.out.println(Arrays.toString(iarr2)); // Bättre

        int i = iarr2[3];    // Indexering
        //i = iarr2[-1];     // Undantag

        System.out.println(iarr2.length);  // Finns alltid attribut längd

        int[] iarr3 = iarr2;   // Tilldelning referenser

        iarr3[2] = 999;      // Delad referens

        System.out.println(iarr2[2]);

    }

    public static void referenceArray() {
        Integer[] iarr1; // Bara *en* variabel med värde null
        Integer[] iarr2 = {1, 2, 3, 4, 5};  // Referenser!!

    }


    public static void shortForLoop() {
        int[] iarr = {1, 2, 3, 4, 5};

        for (int i : iarr) {
            System.out.println(i);
        }
    }

    private static void advancedUseOfArray() {
        final int MAX = 64+1;
        String[] sarr = new String[MAX];
        sarr[0] = "me";
        for (int i = 0; i < MAX / 2; i++) {
            sarr[2 * i + 1] = sarr[i] + ".dad";
            sarr[2 * i + 2] = sarr[i] + ".mum";
        }
        for( String s : sarr){
           System.out.println(s);
        }

    }


}
