import java.util.Random;

/**
 * Using random number generator (better than Math.random)
 *
 * @author hajo
 */
public class EqualPrimitiveAndReference {


    public static void main(String[] args) {
        testEquality1();
        testEquality2();

    }

    private static void testEquality1() {
        int i1 = 4;
        int i2 = 4;
        int i3 = 5;
        System.out.println(i1 == i2);
        System.out.println(i2 == i3);


        Integer j1 = 200;
        Integer j2 = j1;
        Integer j3 = 200;

        System.out.println(j1 == j2);
        System.out.println(j2 == j3);
        System.out.println(j2.equals(j3));


        j2 = 45;
        j3 = 45;

        System.out.println(j2 == j3);  // !!!


    }


    private static void testEquality2() {
        int i1 = 1;
        int i2 = 1;
        System.out.println(i1 == i2);
        System.out.println(i1 >= i2);
        System.out.println(i1 <= i2);

        Integer j1 = 200;
        Integer j2 = 200;
        System.out.println(j1 == j2);
        System.out.println(j1 >= j2);
        System.out.println(j1 <= j2);

        System.out.println(j1.equals(j2));
    }


}
